<?php
//debug
//error_reporting(E_ALL);
require_once(MODX_CORE_PATH.'components/payment/paykeeper/paykeeper.class.php');
$modelpath = $modx->getOption('core_path') . 'components/shopkeeper3/model/';
$modx->addPackage( 'Shopkeeper3', $modelpath );
if (isset($_REQUEST['payment']) && $_REQUEST['payment'] == 'paykeeper') {
    $pk_obj = new PaykeeperPayment();
    $pk_obj->setOrderParams($modx->placeholders['shk.price_total'],                 //sum
                            $_REQUEST["fullname"],                                  //clientid
                            $_REQUEST["id"],                                        //orderid
                            $_REQUEST["email"],                                     //client_email
                            $_REQUEST["phone"],                                     //client_phone
                            "",                                                     //service_name
                            $modx->getOption('form_url', $scriptProperties, null),  //payment form url
                            $modx->getOption('secret_key', $scriptProperties, null) //secret key
    );

    //GENERATE FZ54 CART
    $product_cart_sum = 0;
    $cart_data = $_SESSION['shk_order'];
    foreach ($cart_data as $cart_item) {
        $taxes = array("tax" => "none", "tax_sum" => 0);
        $name = $cart_item["name"];
        $qty = (int) $cart_item["count"];
        $price = (float) $cart_item["price"];
        $sum = (float) number_format($price*$qty, 2, ".", "");
        $product_cart_sum += $sum;
        $tax_rate = $modx->getOption('vat', $scriptProperties, null);
        if (isset($tax_rate)){
            $taxes = $pk_obj->setTaxes($sum, (int) $tax_rate);     
        }

        $pk_obj->updateFiscalCart($pk_obj->getPaymentFormType(), 
                                $name, $price, $qty, $sum, $taxes["tax"], $taxes["tax_sum"]);
    }
    //add shipping parameters to cart
    $shipping_tax_rate = 0;
    $shipping_taxes = array("tax" => "none", "tax_sum" => 0);

    $shipping_name = $_REQUEST["shk_delivery"];
    $pk_obj->setShippingPrice($_SESSION['shk_delivery']['price']);
    if (isset($tax_rate))
        $shipping_taxes = $pk_obj->setTaxes($pk_obj->getShippingPrice(), (int) $tax_rate);
    if ($pk_obj->getShippingPrice() > 0) {
        $pk_obj->setUseDelivery(); //for precision correct check
        $pk_obj->updateFiscalCart($pk_obj->getPaymentFormType(),
                                $shipping_name,
                                $pk_obj->getShippingPrice(), 1, 
                                $pk_obj->getShippingPrice(), 
                                $shipping_taxes["tax"],
                                $shipping_taxes["tax_sum"]);
    }

   //set discounts
   $forced_discount_check = $modx->getOption('forced_discount_check');
  if ($forced_discount_check==1){
         $pk_obj->setDiscounts($product_cart_sum, (float) $order["discount"]);
  }



    //handle possible precision problem
    $pk_obj->correctPrecision($product_cart_sum);

    $fiscal_cart_encoded = json_encode($pk_obj->getFiscalCart());
    //$order = $modx->getObject('shk_order', 14);

    //generate payment form
    $form = "";

    if ($pk_obj->getPaymentFormType() == "create") { //create form
        $to_hash = $pk_obj->getOrderTotal(True)                .
                   $pk_obj->getOrderParams("clientid")     .
                   $pk_obj->getOrderParams("orderid")      .
                   $pk_obj->getOrderParams("service_name") .
                   $pk_obj->getOrderParams("client_email") .
                   $pk_obj->getOrderParams("client_phone") .
                   $pk_obj->getOrderParams("secret_key");
        $sign = hash ('sha256' , $to_hash);
        $pk_obj->setSubmitButtonCSSClass("");
        $form = '
            <h3>Сейчас Вы будете перенаправлены на страницу банка.</h3> 
            <form name="payment" id="pay_form" action="'.$pk_obj->getOrderParams("form_url").'" accept-charset="utf-8" method="post">
            <input type="hidden" name="sum" value = "'.$pk_obj->getOrderTotal(True).'"/>
            <input type="hidden" name="orderid" value = "'.$pk_obj->getOrderParams("orderid").'"/>
            <input type="hidden" name="clientid" value = "'.$pk_obj->getOrderParams("clientid").'"/>
            <input type="hidden" name="client_email" value = "'.$pk_obj->getOrderParams("client_email").'"/>
            <input type="hidden" name="client_phone" value = "'.$pk_obj->getOrderParams("client_phone").'"/>
            <input type="hidden" name="service_name" value = "'.$pk_obj->getOrderParams("service_name").'"/>
            <input type="hidden" name="cart" value = \''.$fiscal_cart_encoded.'\' />
            <input type="hidden" name="sign" value = "'.$sign.'"/>
            <input type="submit" class="'.$pk_obj->getSubmitButtonCSSClass().'" value="Оплатить"/>
            </form>
            <script type="text/javascript">
            window.onload=function(){
                setTimeout(fSubmit, 2000);
            }
            function fSubmit() {
                document.forms["pay_form"].submit();
            }
            </script>';
    }
    else { //order form
        $payment_parameters = array(
            "clientid"=>$pk_obj->getOrderParams("clientid"), 
            "orderid"=>$pk_obj->getOrderParams('orderid'), 
            "sum"=>$pk_obj->getOrderTotal(), 
            "phone"=>$pk_obj->getOrderParams("phone"), 
            "client_email"=>$pk_obj->getOrderParams("client_email"), 
            "cart"=>$fiscal_cart_encoded);
        $query = http_build_query($payment_parameters);
        $err_num = $err_text = NULL;
        if( function_exists( "curl_init" )) { //using curl
            $CR = curl_init();
            curl_setopt($CR, CURLOPT_URL, $pk_obj->getOrderParams("form_url"));
            curl_setopt($CR, CURLOPT_POST, 1);
            curl_setopt($CR, CURLOPT_FAILONERROR, true); 
            curl_setopt($CR, CURLOPT_POSTFIELDS, $query);
            curl_setopt($CR, CURLOPT_RETURNTRANSFER, 1);
            curl_setopt($CR, CURLOPT_SSL_VERIFYPEER, 0);
            $result = curl_exec( $CR );
            $error = curl_error( $CR );
            if( !empty( $error )) {
                $form = "<br/><span class=message>"."INTERNAL ERROR:".$error."</span>";
                return false;
            }
            else {
                $form = $result;
            }
            curl_close($CR);
        }
        else { //using file_get_contents
            if (!ini_get('allow_url_fopen')) {
                $form_html = "<br/><span class=message>"."INTERNAL ERROR: Option allow_url_fopen is not set in php.ini"."</span>";
            }
            else {
                $form = file_get_contents($server, false, $context);
            }
        }
    }
    if ($form  == "") {
        $form = '<h3>Произошла ошибка при инциализации платежа</h3><p>$err_num: '.htmlspecialchars($err_text).'</p>';
    }

    //render form
    echo $form;
    die();

}
else {
    if (isset($scriptProperties['action'])) {
        switch ($scriptProperties['action']) {
            case 'callback':
                $answer = callback($modx, $scriptProperties, $_REQUEST);
                echo $answer;
                die();
            break;
        }
    }
}
    return TRUE;
exit;

function getOrder($modx, $orderId)
{
    return $modx->getObject('shk_order', $orderId);
}

